﻿Public Class Form1
    ' Das Kontextmenu in das alle Einträge kommen
    Private myMenu As New ContextMenuStrip

    Private Sub Form1_FormClosed(ByVal sender As Object, _
            ByVal e As System.Windows.Forms.FormClosedEventArgs) _
            Handles Me.FormClosed

        myMenu.Dispose()
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles MyBase.Load

        Me.CreateKontextMenu()
    End Sub

    ' Öffnen des Kontextmenus
    Private Sub Form1_MouseClick(ByVal sender As Object, _
            ByVal e As System.Windows.Forms.MouseEventArgs) _
            Handles Me.MouseClick

        If e.Button = Windows.Forms.MouseButtons.Right Then
            Me.myMenu.Show(Me, e.Location)
        End If
    End Sub

    ' Erzeugt das Kontextmenu
    Public Sub CreateKontextMenu()
        ' Die Hauptmenus
        Dim mItem1 As ToolStripMenuItem = Me.CreateMenuItem("MainMenu1")
        Dim mItem2 As ToolStripMenuItem = Me.CreateMenuItem("MainMenu2")
        Dim mItem3 As ToolStripMenuItem = Me.CreateMenuItem("MainMenu3")

        ' Ein Item mit dem nun alle Untermenus erzeugt werden
        Dim subItem As ToolStripMenuItem
        For i As Integer = 1 To 4
            ' Item erzeugen
            subItem = Me.CreateMenuItem(mItem2.Text & " - SubMenu" & i.ToString)
            ' Item als SubMenu hinzufügen
            Me.AddSubItem(mItem2, subItem)
        Next

        ' Nun alle Hauptmenus in das Kontextmenu eintragen
        Me.myMenu.Items.Add(mItem1)
        Me.myMenu.Items.Add(New ToolStripSeparator)
        Me.myMenu.Items.Add(mItem2)
        Me.myMenu.Items.Add(New ToolStripSeparator)
        Me.myMenu.Items.Add(mItem3)
    End Sub

    ' Liefert ein ToolStripMenuItem zurück, dessen Click von 
    ' ContextMenu_Click behandelt wird.
    Private Function CreateMenuItem(ByVal text As String, _
            Optional ByVal name As String = "") As ToolStripMenuItem

        ' Einen Event Handler erstellen
        Dim evH As New EventHandler(AddressOf ContextMenu_Click)
        ' Ein neues MenuItem erzeugen
        Dim tsmi As New ToolStripMenuItem(text, Nothing, evH, name)

        Return tsmi
    End Function

    ' Fügt ein MenuItem als SubItem an ein betsehendes MenuItem an
    Private Sub AddSubItem(ByVal owner As ToolStripMenuItem, _
            ByVal item As ToolStripMenuItem)

        ' Item als DropDownMenu dem OwnerMenu hinzufügen.
        owner.DropDownItems.Add(item)
        ' Nun den Event des Besitzers abschalten, denn dieser soll nichts
        ' auslösen.
        RemoveHandler owner.Click, AddressOf ContextMenu_Click
    End Sub

    Private Sub ContextMenu_Click(ByVal sender As Object, ByVal e As EventArgs)
        Dim tsmi As ToolStripMenuItem = DirectCast(sender, ToolStripMenuItem)
        MsgBox("ContextMenu - " & tsmi.Text & " was clicked!")
    End Sub
End Class
